<?php
/**
 * This project has been generated by nuts generator
 * nuts has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 */
use Monolog\Handler\StreamHandler;
use Monolog\Logger;
use Slim\Http\Request;
use Slim\Http\Response;

require __DIR__ . '/config/env.php';
require 'vendor/autoload.php';
require __DIR__ . '/config/errorCode.php';
//$app = new \Provider\IAM\Core\Slim\OverideCoreSlim($environment['development']);
$app = new \Slim\App($environment["development"]);
$container = $app->getContainer();
$container["app"] = $environment['development'];

require __DIR__ . '/config/container.php';

$container['errorHandler'] = $errorHandler;
$container["notFoundHandler"] = $notFoundHandler;
require __DIR__ . '/config/database.php';

$stream = new StreamHandler(__DIR__ . '/logs/' . \Carbon\Carbon::now()->month . '-service.log', Logger::DEBUG);
$logger = new Logger('service');
$logger->pushHandler($stream);
$container['logger'] = $logger;

$app->get("/", function (Request $request, Response $response) {
	$library = file_get_contents(__DIR__ . '/composer.json');
	$property = json_decode($library);
	$intro = array(
		"timestamp" => (integer)microtime(true),
		"statusCode" => 200,
		"message" => array(
			"title" => "NUTS GENERATOR",
			"createdBy" => "fahmi sulaiman",
			"license" => "Apache v.2.0",
			"version" => "v.0.0.1",
			"library" => $property->require,
		),
	);
	return $response->withJson($intro);
});


$app->group("/berak/", function () use ($app) {
	$app->group("families", function () use ($app) {
        $app->post("/paging", "Controller\FamilyController:paging");
        $app->get("/{id}", "Controller\FamilyController:show");
		$app->get("[/]", "Controller\FamilyController:index");
		$app->delete("/{id}/delete", "Controller\FamilyController:delete");
		$app->put("/{id}/update", "Controller\FamilyController:update");
        $app->post("[/]", "Controller\FamilyController:store");

	});
	$app->group("family", function () use ($app) {
		$app->get("[/]", "Controller\FamilyusersController:index");
		$app->post("[/]", "Controller\FamilyusersController:store");
		$app->post("/paging", "Controller\FamilyusersController:paging");
		$app->delete("/{id}/delete", "Controller\FamilyusersController:delete");
		$app->put("/{id}/update", "Controller\FamilyusersController:update");
		$app->get("/{id}", "Controller\FamilyusersController:show");
	});
	$app->group("account-bank", function () use ($app) {
		$app->get("[/]", "Controller\AccountbankController:index");
		$app->post("[/]", "Controller\AccountbankController:store");
		$app->post("/paging", "Controller\AccountbankController:paging");
		$app->delete("/{id}/delete", "Controller\AccountbankController:delete");
		$app->put("/{id}/update", "Controller\AccountbankController:update");
		$app->get("/{id}", "Controller\AccountbankController:show");
	});
	$app->group("category", function () use ($app) {
		$app->get("[/]", "Controller\CategoryController:index");
		$app->post("[/]", "Controller\CategoryController:store");
		$app->post("/paging", "Controller\CategoryController:paging");
		$app->delete("/{id}/delete", "Controller\CategoryController:delete");
		$app->put("/{id}/update", "Controller\CategoryController:update");
		$app->get("/{id}", "Controller\CategoryController:show");
	});
	$app->group("transactions", function () use ($app) {
		$app->get("[/]", "Controller\TransactionController:index");
		$app->post("[/]", "Controller\TransactionController:store");
		$app->post("/paging", "Controller\TransactionController:paging");
		$app->delete("/{id}/delete", "Controller\TransactionController:delete");
		$app->put("/{id}/update", "Controller\TransactionController:update");
		$app->get("/{id}", "Controller\TransactionController:show");
	});
	$app->group("banks", function () use ($app) {
		$app->get("[/]", "Controller\BanksController:index");
		$app->post("[/]", "Controller\BanksController:store");
		$app->post("/paging", "Controller\BanksController:paging");
		$app->delete("/{id}/delete", "Controller\BanksController:delete");
		$app->put("/{id}/update", "Controller\BanksController:update");
		$app->get("/{id}", "Controller\BanksController:show");
	});
	$app->group("transaction-debit", function () use ($app) {
		$app->get("[/]", "Controller\TransactiondebitController:index");
		$app->post("[/]", "Controller\TransactiondebitController:store");
		$app->post("/paging", "Controller\TransactiondebitController:paging");
		$app->delete("/{id}/delete", "Controller\TransactiondebitController:delete");
		$app->put("/{id}/update", "Controller\TransactiondebitController:update");
		$app->get("/{id}", "Controller\TransactiondebitController:show");
	});
});

$app->run();